#!/bin/sh
SOFTWAREPACKET=software*
SOFTWAREVERSION="1.3.0"
KERNELPACKET=kernel*
KERNELVERSION="5.6.0"
M3HEX=Creator4.hex
M3HEXPACKET=control*
M3HEXVERSION="3.1.4"
LIBPACKET=library*
LIBVERSION="1.0.0"
LOG=/data/log/guider3plus.log
MACHINE_ARCH=armv7l
VERSIONCFG=version.cfg
BUILDTIME="20221212"
WORKDIR=$(cd `dirname $0`; pwd)
echo "WORKDIR="$WORKDIR >> $LOG
if [ ! -f /opt/$VERSIONCFG ]
then
    touch /opt/$VERSIONCFG
fi
sync
echo "[VersionInfo]" > /opt/$VERSIONCFG
echo "UpdateFlag=0" >> /opt/$VERSIONCFG
echo "BuildTime="$BUILDTIME >> /opt/$VERSIONCFG
echo "SoftwareVersion="$SOFTWAREVERSION >> /opt/$VERSIONCFG
echo "LibVersion="$LIBVERSION >> /opt/$VERSIONCFG
echo "ControlVersion="$M3HEXVERSION >> /opt/$VERSIONCFG
echo "KernelVersion="$KERNELVERSION >> /opt/$VERSIONCFG
#检测机器的架构,错误马上退出
CHECH_ARCH=`uname -m`
if [ "${MACHINE_ARCH}" != "${CHECH_ARCH}" ];then
	echo "updateInfo=Machine architecture error." >> /opt/$VERSIONCFG
	exit 1
fi

cp $WORKDIR/complete.img /opt/
cp $WORKDIR/start.img /opt/

if [ -f $WORKDIR/logo.img ]; then
    cp -f $WORKDIR/logo.img /opt
fi

if [ -f $WORKDIR/rtl_hostapd_2G.conf ]; then
    cp -f $WORKDIR/rtl_hostapd_2G.conf /etc
fi

if [ -f $WORKDIR/wpa_supplicant.conf ]; then
    cp -f $WORKDIR/wpa_supplicant.conf /etc/
fi

echo "dispaly start on lcd" >> $LOG
if [ -f $WORKDIR/start.img ]
then
    cat $WORKDIR/start.img > /dev/fb0
fi

if [ ! -d /data/log ]; then
	mkdir /data/log
fi

if [ ! -d /data/update ]; then
	mkdir /data/update
fi

if [ ! -d /media ]; then
	mkdir /media
fi

if [ ! -d /opt/kernel ]; then
	mkdir /opt/kernel
fi

if [ ! -d /opt/control ]; then
	mkdir /opt/control
fi

if [ ! -d /opt/library ]; then
	mkdir /opt/library
fi

if [ ! -d /opt/software ]; then
	mkdir /opt/software
fi

cp -f $WORKDIR/mydaemon.out /opt/

if [ -f $WORKDIR/mydaemon.out ]; then
    cp -f $WORKDIR/mydaemon.out /opt
	chmod a+x /opt/mydaemon.out
fi

if [ -f $WORKDIR/8821cu.ko ]; then
    cp -f $WORKDIR/8821cu.ko /lib/modules/
fi

if [ -f $WORKDIR/rcS ]; then
    cp -f $WORKDIR/rcS /etc/init.d/
	chmod a+x /etc/init.d/rcS
fi
sync

if [ -f $WORKDIR/ffstartup.cfg ]; then
    cp -f $WORKDIR/ffstartup.cfg /opt/
fi
sync

#if [ ! -d /opt/libssioclient ]; then
#	tar -xvf $WORKDIR/libssioclient.tar -C /opt/
#	echo "update libssioclient success" >> $LOG
#	sync
#fi

#if [ ! -d /opt/boost ]; then
#	tar -xvf $WORKDIR/boost.tar -C /opt/
#	echo "update boost success" >> $LOG
#	sync
#fi

#if [ ! -d /opt/qt4.8.6 ]; then
#	tar -xvf $WORKDIR/qt4.8.6.tar -C /opt/
#	echo "update qt4.8.6 success" >> $LOG
#	sync
#fi

if [ -f $WORKDIR/mjpg-streamer.tar ]; then
		echo "tar camera.tar"  >> $LOG
		tar -xvf $WORKDIR/mjpg-streamer.tar -C /opt/
		chmod 777 /opt/mjpg-streamer/* -Rf
		echo "update camera success" >> $LOG
		sync
fi

key_dir=/opt/
key_pair=${key_dir}private.pem
public_key=${key_dir}key.pub
private_key=${key_dir}key.priv
password=abcd

if [ ! -f ${key_pair} ];then
	export PATH=/opt/openssl-1.0.2/bin:$PATH
	export OPENSSL_DIR=/opt/openssl-1.0.2
	export LD_LIBRARY_PATH=$OPENSSL_DIR/lib:$LD_LIBRARY_PATH
	echo "CREATE RSA"
	# Generate the key pair
	openssl genrsa -des3 -passout pass:${password} -out ${key_pair} 2048
	# Save the RSA public key in the file key.pub
	openssl rsa -in ${key_pair} -passin pass:${password} -outform PEM -pubout -out ${public_key}
	# Save the RSA private key in the file key.priv
	openssl rsa -in ${key_pair} -passin pass:${password} -out ${private_key} -outform PEM
fi


	
ls -1t $WORKDIR/$KERNELPACKET
if [ $? -eq 0 ]; then
	UIMAGETXZ=`ls -1t $WORKDIR/$KERNELPACKET | head -n 1`
	xz -d  $UIMAGETXZ 
	UIMAGETAR=`ls -1t $WORKDIR/$KERNELPACKET | head -n 1`
	if [ -f $UIMAGETAR ]; then
	    rm -rf /opt/kernel/*	
		mkdir /opt/kernel/temp	
		tar -xf $UIMAGETAR -C /opt/kernel/temp
		if [ ! -d /tmp/disk1 ]; then
			mkdir /tmp/disk1
		fi
		mount -t vfat -o codepage=936,iocharset=utf8 /dev/mmcblk0p1 /tmp/disk1
		if [ $? -ne 0 ]; then
			if [ -f $WORKDIR/failed.img ]; then
				cat $WORKDIR/failed.img > /dev/fb0
			fi
			sync
		fi	
		cd /opt/kernel/temp
		md5sum -c md5sum.list
		if [ $? -eq 0 ]; then		
			cp -rf /opt/kernel/temp /opt/kernel/$KERNELVERSION
			rm -rf /opt/kernel/temp
			echo "update uImage" >> $LOG
			cp -f /opt/kernel/$KERNELVERSION/uImage  /tmp/disk1/
			cp -f /opt/kernel/$KERNELVERSION/script.bin /tmp/disk1/
			cp -f /opt/kernel/$KERNELVERSION/sun8i-s3-flashforge.dtb /tmp/disk1/
			sync	
			echo "update uImage success" >> $LOG
			umount /tmp/disk1
			
		else
			echo "md5sum failed" >> $LOG
			if [ -f $WORKDIR/failed.img ]; then
				cat $WORKDIR/failed.img > /dev/fb0
			fi
			sync
			exit 1
		fi	
	fi
fi

sync


ls -1t $WORKDIR/$SOFTWAREPACKET
if [ $? -eq 0 ]; then
	SOFTWAREXZ=`ls -1t $WORKDIR/$SOFTWAREPACKET | head -n 1`
	xz -d $SOFTWAREXZ
	SOFTWARETAR=`ls -1t $WORKDIR/$SOFTWAREPACKET | head -n 1`
	if [ -f $SOFTWARETAR ]; then
		if [ ! -d /opt/software/temp ]; then
			mkdir /opt/software/temp	
		fi
		tar -xf $SOFTWARETAR -C /opt/software/temp
		sync
		cd  /opt/software/
		softwareDir=$(ls -ld [0-9]* |awk '/^d/ {print $NF}')
		for oldSoftwareVer in $softwareDir 
		do
			echo $oldSoftwareVer
		done
		cd /opt/software/temp
		md5sum -c md5sum.list
		if [ $? -eq 0 ]; then	
			if [ "$oldSoftwareVer" > $SOFTWAREVERSION ]; then
				baseDir="0.0.0"
				echo $oldSoftwareVer ">" $SOFTWAREVERSION >> $LOG
				cp -rf /opt/software/$oldSoftwareVer  /opt/software/$baseDir
				cd /opt/software/
				rm -rf $oldSoftwareVer
			fi
			cp -f /opt/software/temp/auto_run.sh   /opt/ 			
			mkdir /opt/software/$SOFTWAREVERSION
			cp -rf /opt/software/temp/* /opt/software/$SOFTWAREVERSION
			rm -rf /opt/software/temp		
			echo "update software success" >> $LOG
			sync
		fi
	fi
fi

sync

ls -1t $WORKDIR/$LIBPACKET
if [ $? -eq 0 ]; then
	cd  /opt/library/
	libDir=$(ls -ld [0-9]* |awk '/^d/ {print $NF}')
	for oldLibVer in $libDir 
	do
		echo $oldLibVer
	done
	if [ "$oldLibVer" == $LIBVERSION ]; then
		echo "The same Lib version!" >> $LOG
	else
		LIBTXZ=`ls -1t $WORKDIR/$LIBPACKET | head -n 1`
		xz -d $LIBTXZ 
		LIBTAR=`ls -1t $WORKDIR/$LIBPACKET | head -n 1`
		if [ -f $LIBTAR ]; then
			if [ ! -d /opt/library/temp ]; then
				mkdir /opt/library/temp	
			fi
			tar -xf $LIBTAR -C /opt/library/temp
			sync
			cd /opt/library/temp
			md5sum -c md5sum.list
			if [ $? -eq 0 ]; then
				mkdir /opt/library/$LIBVERSION
				cp -rf /opt/library/temp/* /opt/library/$LIBVERSION
				rm -rf /opt/library/temp
				cd /opt/library/
				rm -r $oldLibVer
				echo "update LIB" >> $LOG
				sync
			fi
		fi
	fi
fi
sync

ls -1t $WORKDIR/$M3HEXPACKET
if [ $? -eq 0 ]; then
	M3HEXXZ=`ls -1t $WORKDIR/$M3HEXPACKET | head -n 1`
	xz -d  $M3HEXXZ
	M3HEXTAR=`ls -1t $WORKDIR/$M3HEXPACKET | head -n 1`
	if [ -f $M3HEXTAR ]; then
		rm -rf /opt/control/*
		mkdir /opt/control/temp	
		tar -xf $M3HEXTAR -C /opt/control/temp
		sync
		cd /opt/control/temp
		md5sum -c md5sum.list
		if [ $? -eq 0 ]; then		
			cp -rf /opt/control/temp /opt/control/$M3HEXVERSION
			rm -rf /opt/control/temp
			echo "burn M3 firmware..." >> $LOG
			/opt/control/$M3HEXVERSION/update.sh
			sync
		    echo "UpdateFlag=1" >> /opt/$VERSIONCFG
		fi
	fi
else
	echo "UpdateFlag=1" >> /opt/$VERSIONCFG
	if [ -f $WORKDIR/complete.img ]
	then
		cat $WORKDIR/complete.img > /dev/fb0
	fi

	if [ -f $WORKDIR/play ]; then
		echo "play complete music" >> $LOG
		chmod a+x $WORKDIR/play
		$WORKDIR/play 
	fi
fi


