#!/bin/sh
# Author:		和岩波
# Description:	单个固件包升级程序
# Date:			2019-10-28

set -x

WORK_DIR=`dirname $0`

FIRMWARE_M3=G3S.bin

#检测机器的架构,错误马上退出
#CHECH_ARCH=`uname -m`
#if [ "${CHECH_ARCH}" != "armv7l" ];then
#    echo "Machine architecture error."
#    echo ${CHECH_ARCH}
#    exit 1
#fi

#检测内核版本，错误马上退出
#CHECH_KERNEL=`uname -r`
#if [ "${CHECH_KERNEL}" != "3.4.39+" ];then
#    echo "Kernel version error."
#    echo ${CHECH_KERNEL}
#    exit 1
#fi

if [ -f $WORK_DIR//ffstartup.cfg ]; then
    cp -f $WORK_DIR//ffstartup.cfg /opt/
fi
sync

if [ ! -d /opt/libssioclient ]; then
	tar -xvf $WORK_DIR/libssioclient.tar -C /opt/
	echo "update libssioclient success" >> $LOG
	sync
fi

if [ ! -d /opt/boost ]; then
	tar -xvf $WORK_DIR/boost.tar -C /opt/
	echo "update boost success" >> $LOG
	sync
fi

if [ ! -d /opt/qt4.8.6 ]; then
	tar -xvf $WORK_DIR/qt4.8.6.tar -C /opt/
	echo "update qt4.8.6 success" >> $LOG
	sync
fi

if [ -f $WORK_DIR/NationsCommand ];then
	chmod a+x $WORK_DIR/NationsCommand
	if [ -f $WORK_DIR/$FIRMWARE_M3 ];then
		echo "burn M3 firmware..."
		$WORK_DIR/NationsCommand -c -d --fn $WORK_DIR/$FIRMWARE_M3 --v -r
	fi
fi

exit 0
